'\"
'\" Copyright (c) 2002 Pascal Scheffers <pascal@scheffers.net>
'\"
'\" See the file "COPYING" for information on usage and redistribution
'\" 
'\" RCS: @(#) $Id: xmmstcl.n,v 1.3 2002/06/14 07:35:56 pascal Exp $
'\" 
.so man.macros
.TH xmms n 1.1.1 Tcl "Xmms Remote Control"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
xmms \- Send commands to the xmms player
.SH SYNOPSIS
\fBxmms \fIcommand \fR?\fIarg arg ... -session n\fR?
.BE

.SH DESCRIPTION
.PP
This command provides access to the xmms media player to control playback,
playlist, skins and equalizer functions. The optional \fR?\fI-session
n\fR? can be used to specify a specific xmms player session, this
defaults to session \fI0\fR and only makes sense when 'allow multiple
instances' of the xmms player options has been set.

The legal \fIcommand\fR's are:
.TP
\fBxmms isrunning \fR?\fI-session n\fR?
Returns 1 if xmms is running, 0 otherwise.
.TP
\fBxmms run \fR?\fI-timeout n path arg arg ...\fR?
Starts a new xmms session and returns the session id, raises an error
if a new session could not be created (timeout, out of memory,
etc.). You can specify path and args 
to xmms, by default the path is seached for xmms. If you only want to
specify args, but the path should be used to find xmms, the
?\fIpath\fR? should be specified as 'xmms'. ?\fI-timeout n\fR? defaults to 5000
milliseconds, and can be used to specify how long to wait for the new
session. If you specify a ?\fI-timeout\fR? value of 0, xmms will not
yet be running when 'xmms run' returns, but no error will be raised
either. The ?\fI-session n\fR? argument must not be specified for this
subcommand.
.TP
\fBxmms version \fR?\fI-session n\fR?
Returns the xmms version number (integer).
.TP
\fBxmms playlist \fR?\fInewlist -titles -session n\fR?
Returns a list with all the filenames (default) or titles (if ?\fI-titles\fR? is
specified) in the current playlist. Replaces the entire playlist by
the file names specified in \fInewlist\fR.
.TP
\fBxmms add \fR?\fIlist -titles -session n\fR?
Returns all the filenames (default) or titles (if ?\fI-titles\fR? is
specified) in the current playlist. Appends the file names specified
in \fIlist\fR to the current playlist.
.TP
\fBxmms addurl \fR?\fIurl -session n\fR?
Adds ?\fIurl\fR? to the current playlist.
.TP
\fBxmms delete \fR?\fIpos -session n\fR?
Deletes the current or the playlist entry at ?\fIpos\fR?. 
\fBNOTE: Playlist positions range from 0 to [xmms length]\-1.\fR
.TP
\fBxmms play \fR?\fI-session n\fR?
Returns the current isplaying state. Starts/resumes playback.
.TP
\fBxmms pause \fR?\fI-session n\fR?
Returns the current ispaused state. Pauses playback.
.TP
\fBxmms stop \fR?\fI-session n\fR?
Returns the current isstopped state. Stops playback.
.TP
\fBxmms previous \fR?\fI-session n\fR?
Jumps to the previous track and starts playback.
.TP
\fBxmms next \fR?\fI-session n\fR?
Jumps to the next track and starts playback.
.TP
\fBxmms isplaying \fR?\fI-session n\fR?
Returns the current isplaying state.
.TP
\fBxmms ispaused \fR?\fI-session n\fR?
Returns the current ispaused state.
.TP
\fBxmms position \fR?\fInewpos -session n\fR?
Returns the current playlist position. Set the playlist position to
?\fInewpos\fR?.
\fBNOTE: Playlist positions range from 0 to [xmms length]\-1.\fR
.TP
\fBxmms length \fR?\fI-session n\fR?
Returns the number of items in the current playlist. 
.TP
\fBxmms clear \fR?\fI-session n\fR?
Deletes all items from the current playlist.
.TP
\fBxmms time \fR?\fInewtimeindex -session n\fR?
Returns the current playback position in milliseconds. Jumps to ?\fInewtimeindex\fR?.
.TP
\fBxmms duration \fR?\fIposition -session n\fR?  Returns the duration
of the current playlist item in milliseconds, or the duration of the
playlist item at ?\fIposition\fR?.
.TP
\fBxmms volume \fR?\fIleftchannel rightchannel -session n\fR?
Returns a two element list with the left and the right channel
volumes. Sets the playback volume for the left and right channel
individualy. If only ?\fIleftchannel\fR? is specified,
\fIrightchannel\fR will be set to the same level.
Volumes range from 0 to 100 percent
.TP
\fBxmms mainvolume \fR?\fIlevel -session n\fR?
Returns the mainvolume level. Set the mainvolume to ?\fIlevel\fR?, left and right channel will have the same value. 
.TP
\fBxmms balance \fR?\fIbalance -session n\fR?
Returns the balance between the left and right channel. Balance is calculated bu subtracting the right channel level from the left channel level. Sets the balance to ?\fIbalance\fR?.
.TP
\fBxmms file \fR?\fIpos -session n\fR?
Returns the filename at ?\fIpos\fR? or the current filename.
.TP
\fBxmms title \fR?\fIpos -session n\fR?
Returns the title at ?\fIpos\fR? or the current title.
.TP
\fBxmms info \fR?\fI-session n\fR?
Returns a three element list containing the current bitrate, sample
frequency and number of channels.  
.TP
\fBxmms onchange callback_proc \fR?\fI-cancel -session n\fR?
Registers a callback procedure. This procedure will be called whenever
the session starts and quits, the playback state (isplaying, ispaused)
changes, the playlist position, the current title changes or the
current filename changes.

The callback procedure should be defined as 'proc MyCallback {args}
body', the args list can be used with the 'array' command: 'array set
MyArray $args' to obtain an array with the elements: session
isrunning, isplaying, ispaused, title, file, duration, position and length (of
the playlist). Change notification is session specific (and persists
even when the specified session quits). 

The callback can be unregistered by specifying ?\fI-cancel\fR?.
.TP
\fBxmms eq \fR?\fIlist -session n\fR?
Returns an eleven element list with the preamp setting and the ten
equalizer bands. Sets the preamp and ten equalizer bands to the values
in ?\fIlist\fR?. ?\fIlist\fR? list must have eleven floating point
entries. All values range from -20 to +20.
.TP
\fBxmms eqpreamp \fR?\fInewlevel -session n\fR?
Returns the current preamp setting. Sets the preamp level to fR?\fInewlevel\fR?.
.TP
\fBxmms eqband \fR?\fIband newlevel -session n\fR?
Returns the current level for equalizer band ?\fIband\fR?. Sets the
level for for equalizer band ?\fIband\fR? to fR?\fInewlevel\fR?.
.TP
\fBxmms repeat \fR?\fInewstate -session n\fR?
Returns the current repeat state. Sets the repeat state to ?\fInewstate\fR?.
.TP
\fBxmms shuffle \fR?\fInewstate -session n\fR?
Returns the current shuffle state. Sets the shuffle state to ?\fInewstate\fR?.
.TP
\fBxmms mainwindow \fR?\fInewstate -session n\fR?
Returns the current mainwindow visibility state, 0 for invisisble, 1
for visible. Sets the state to
?\fInewstate\fR?. NOTE: Depending on the window manager currently in
use, the user may not be able to restore the mainwindow.
.TP
\fBxmms plwindow \fR?\fInewstate -session n\fR?
Returns the current playlist window visibility state, 0 for invisisble, 1
for visible. Sets the state to ?\fInewstate\fR?.
.TP
\fBxmms eqwindow \fR?\fInewstate -session n\fR?
Returns the current equalizer window visibility state, 0 for invisisble, 1
for visible. Sets the state to ?\fInewstate\fR?.
.TP
\fBxmms showpreferences \fR?\fI-session n\fR?
Opens the preferences window (does not return the current state).
.TP
\fBxmms alwaysontop \fR?\fI-session n\fR?
Toggles the always on to state (does not return the current state).
.TP
\fBxmms eject \fR?\fI-session n\fR?
Opens the add files dialog (does not return the current state).
.TP
\fBxmms skin \fR?\fIskinfile -session n\fR?
Returns the current skin file. Sets the skinfile to ?\fIskinfile\fR?
.TP
\fBxmms quit \fR?\fI-session n\fR?
Closes the xmms session.

.SH KEYWORDS
xmms
